

import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.util.logging.Level;
import java.util.logging.Logger;

public class UDP_SERVER_UNI {
        public static double bitrate=1; //mbps
         public static int  packet_size=30; //byte
public static void main(String[] args) 
    {
        System.out.println("hello");
	int arg_c=args.length;

	if(arg_c > 0) 
        {
	      bitrate=Double.valueOf(args[0])*1000000;//convert to Mega
              packet_size=1000*8; //convert to bit (1000byte)
        }
        try {
		      int port = Integer.valueOf(args[1]);
		      byte[] addr=new byte[4];
			String Channel_name=args[2];
		       InetAddress address = InetAddress.getByName(Channel_name);
		      DatagramSocket dsocket = new DatagramSocket();
		      double f_size=0; 
		      if(packet_size!=0)
		       {
			  f_size=bitrate/packet_size; //PPS
		       }
			double packet_interval=1000/f_size;//in ms 
                       long count=1;
		      long dd=System.currentTimeMillis();
				  while(true){
						String send_message="";
						for(int i=0; i<(packet_size/8); i++)  send_message+="R"; 
				            	long f=System.currentTimeMillis();
		      				send_message+="_"+String.valueOf(f)+"_"+"*"+String.valueOf(count)+"*";
		      
		      			    byte[] message = send_message.getBytes();
				       	   DatagramPacket packet = new DatagramPacket(message, message.length,address, port);
					long dd2=System.currentTimeMillis();
					if((dd2-dd)>packet_interval){
					      dsocket.send(packet);
					      count++;
					    System.out.println("sent:"+"Server"+" packet_no "+count);
					      dd=dd2;
				           }
					}
			// dsocket.close();
		      
           
    } catch (Exception e) {
      System.err.println(e);
    }
        
    }

    
}
