import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.Serializable;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.MulticastSocket;
import java.net.UnknownHostException;
import java.net.SocketTimeoutException;
import java.nio.ByteBuffer;
import java.sql.Time;
import java.io.*;
import java.net.*;
import java.util.Timer;

public class UDP_Client_UNI {
 static int buf_len=200;
static   long[] packetID_buffer=new long[buf_len];

public  static boolean check_buffer(long item)
{
   boolean result=false;
   for(int i=0; i<buf_len;i++)
     if(packetID_buffer[i]==item) result=true;
  return result;
}
    
    public static void main(String[] args) throws UnknownHostException {
			    try {
			      int port = Integer.valueOf(args[0]);
			      DatagramSocket dsocket = new DatagramSocket(port);
			      byte[] buffer = new byte[90048];
			      int count=0;
			      DatagramPacket packet = new DatagramPacket(buffer, buffer.length);
                                  int index=0;
			      while (true) {
				dsocket.receive(packet);
				String msg = new String(buffer, 0, packet.getLength());
		                long t= Long.valueOf(msg.substring(msg.indexOf("_")+1, msg.lastIndexOf("_")));
		                long delay=System.currentTimeMillis()-t;
		               long h=System.currentTimeMillis();
                                char w='P';
                                  long pnum=Integer.valueOf(msg.substring(msg.indexOf("*")+1,msg.lastIndexOf("*")));
                                 if(check_buffer(pnum)) w='B';
	                	System.out.println(" Delay is= "+delay+" packet_number= "+pnum+"  " +w+" "+System.currentTimeMillis());
                                  if(index==buf_len)index=0;
		                packetID_buffer[index++]=pnum;
}
  } catch (Exception e) {
      System.out.println(e);
    }
    }


    public static String convert_time(long t)
    {
    	long second = (t / 1000) % 60;
        long minute = (t / (1000 * 60)) % 60;
        long hour = (t / (1000 * 60 * 60)) % 24;
        String time = String.format("%02d:%02d:%02d:%d", hour, minute, second,t);
        return time;
    }
	

}
