#!/bin/bash

sim_time=100
fail_time=10
correct_time=10
h="Normal"
rm -f /home/rezmo/opendaylight/plugins/routing.MY_TE_TECH-0.4.1-SNAPSHOT.jar

cp routing.MY_TE_TECH-0.4.1-SNAPSHOT.jar /home/rezmo/opendaylight/plugins/routing.MY_TE_TECH-0.4.1-SNAPSHOT.jar

if [ "$2" = "$h" ]
then
for (( n=1; n<=1; n+=1))
do
	for (( c=1; c<=6; c+=1))
	do

		sudo ./$1.py $sim_time  $fail_time   $c $c $2/$1 $n
		for (( i=1; i<=4; i+=1))
		do
		 	 awk -f loss.awk -v filename=results/$2/$1/send_SERVER$i"_"$c"_"$n.log results/$2/$1/rec_result_$i"_"$c"_"$n.txt >> extractedresults/$1/$2"_"LOSS$c"_"$n.TXT

			awk -f delay.awk results/$2/$1/rec_result_$i"_"$c"_"$n.txt >> extractedresults/$1/$2"_"DELAY$c"_"$n.TXT 

		 	awk -f jitter.awk results/$2/$1/rec_result_$i"_"$c"_"$n.txt >> extractedresults/$1/$2"_"JITTER$c"_"$n.TXT 
		done
               sudo mn -c
	done;
	done;
fi


echo $2
t="Fault_Tolerance"
if [ "$2" = "$t" ]
then
for (( n=1; n<=1; n+=1))
do
	for (( c=1; c<=6; c+=1))
	do
		rm -f /home/rezmo/opendaylight/calc_time.txt
		sudo ./$1.py $sim_time  $fail_time   $c $c $2/$1 $n

		mv /home/rezmo/opendaylight/calc_time.txt results/$2/$1/calc_time_$2"_"$c"_"$n.txt

		mv /home/rezmo/opendaylight/HostFailLogFile.txt results/$2/$1/HostFailLogFile_$2"_"$c"_"$n.txt

		 awk -f calc_time.awk results/$2/$1/calc_time_$2"_"$c"_"$n.txt >> extractedresults/$1/$2_CALC_TIME$c_$n.TXT

		for (( i=1; i<=4; i+=1))
		do

			awk -f recovery_time_fault_tolerance.awk results/$2/$1/rec_result_$i"_"$c"_"$n.txt >> extractedresults/$1/RECOVERY$c"_"$n.TXT
		 	 awk -f loss.awk -v filename=results/$2/$1/send_SERVER$i"_"$c"_"$n.log results/$2/$1/rec_result_$i"_"$c"_"$n.txt >> extractedresults/$1/$2"_"LOSS$c"_"$n.TXT

			awk -f delay.awk results/$2/$1/rec_result_$i"_"$c"_"$n.txt >> extractedresults/$1/$2"_"DELAY"_"$c"_"$n.TXT 
		 	awk -f jitter.awk results/$2/$1/rec_result_$i"_"$c"_"$n.txt >> extractedresults/$1/$2"_"JITTER"_"$c"_"$n.TXT 
		 	awk -f failtime.awk results/$2/$1/rec_result_$i"_"$c"_"$n.txt >> extractedresults/$1/$2"_"FailTime"_"$c"_"$n.TXT 
		done
               sudo mn -c
	done;
done;
fi




echo $2
t="DP"
if [ "$2" = "$t" ]
then
for (( n=1; n<=1; n+=1))
do
	for (( c=1; c<=6; c+=1))
	do
		rm -f /home/rezmo/opendaylight/calc_time.txt
		sudo ./$1.py $sim_time  $fail_time   $c $c $2/$1 $n

		mv /home/rezmo/opendaylight/calc_time.txt results/$2/$1/calc_time_$2"_"$c"_"$n.txt

		mv /home/rezmo/opendaylight/HostFailLogFile.txt results/$2/$1/HostFailLogFile_$2"_"$c"_"$n.txt

		 awk -f calc_time.awk results/$2/$1/calc_time_$2"_"$c"_"$n.txt >> extractedresults/$1/$2_CALC_TIME$c_$n.TXT

		for (( i=1; i<=4; i+=1))
		do

			awk -f recovery_time_fault_tolerance.awk results/$2/$1/rec_result_$i"_"$c"_"$n.txt >> extractedresults/$1/RECOVERY$c"_"$n.TXT
		 	 awk -f loss.awk -v filename=results/$2/$1/send_SERVER$i"_"$c"_"$n.log results/$2/$1/rec_result_$i"_"$c"_"$n.txt >> extractedresults/$1/$2"_"LOSS$c"_"$n.TXT

			awk -f delay.awk results/$2/$1/rec_result_$i"_"$c"_"$n.txt >> extractedresults/$1/$2"_"DELAY"_"$c"_"$n.TXT 
		 	awk -f jitter.awk results/$2/$1/rec_result_$i"_"$c"_"$n.txt >> extractedresults/$1/$2"_"JITTER"_"$c"_"$n.TXT 
		 	awk -f failtime.awk results/$2/$1/rec_result_$i"_"$c"_"$n.txt >> extractedresults/$1/$2"_"FailTime"_"$c"_"$n.TXT 
		done
               sudo mn -c
	done;
done;
fi
#================================================================================================================================








