#!/bin/bash

echo "Algorithm: Normal" > /home/rezmo/opendaylight/Inputs.txt
echo "Interval: 20000" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.2*10.0.0.5" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.3*10.0.0.1" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.6*10.0.0.2" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 1,2" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 1,3" >> /home/rezmo/opendaylight/Inputs.txt
echo "3--4" >> /home/rezmo/opendaylight/Inputs.txt
echo "5--4" >> /home/rezmo/opendaylight/Inputs.txt
echo "5--1" >> /home/rezmo/opendaylight/Inputs.txt

#./run_scenarios.sh Small_topo Normal


echo "Algorithm: FT" > /home/rezmo/opendaylight/Inputs.txt
echo "Interval: 20000" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.2*10.0.0.5" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.3*10.0.0.1" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.6*10.0.0.2" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 1,2" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 1,3" >> /home/rezmo/opendaylight/Inputs.txt
echo "3--4" >> /home/rezmo/opendaylight/Inputs.txt
echo "5--4" >> /home/rezmo/opendaylight/Inputs.txt
echo "5--1" >> /home/rezmo/opendaylight/Inputs.txt



#./run_scenarios.sh Small_topo Fault_Tolerance


echo "Algorithm: DP" > /home/rezmo/opendaylight/Inputs.txt
echo "Interval: 20000" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.2*10.0.0.5" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.3*10.0.0.1" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.6*10.0.0.2" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 1,2" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 1,3" >> /home/rezmo/opendaylight/Inputs.txt
echo "3--4" >> /home/rezmo/opendaylight/Inputs.txt
echo "5--4" >> /home/rezmo/opendaylight/Inputs.txt
echo "5--1" >> /home/rezmo/opendaylight/Inputs.txt



#./run_scenarios.sh Small_topo DP


echo "Algorithm: Normal" > /home/rezmo/opendaylight/Inputs.txt
echo "Interval: 20000" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.1*10.0.0.9" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.2*10.0.0.10" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.3*10.0.0.11" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.4*10.0.0.12" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.5*10.0.0.13" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.6*10.0.0.14" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.7*10.0.0.15" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.8*10.0.0.16" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.8*10.0.0.17" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.4*10.0.0.18" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 6,5" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 6,9" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 13,6" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 13,12" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 10,8" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 10,9" >> /home/rezmo/opendaylight/Inputs.txt
echo "1--2" >> /home/rezmo/opendaylight/Inputs.txt
echo "1--4" >> /home/rezmo/opendaylight/Inputs.txt
echo "1--9" >> /home/rezmo/opendaylight/Inputs.txt
echo "4--5" >> /home/rezmo/opendaylight/Inputs.txt
echo "4--11" >> /home/rezmo/opendaylight/Inputs.txt
echo "11--12" >> /home/rezmo/opendaylight/Inputs.txt
echo "15--7" >> /home/rezmo/opendaylight/Inputs.txt
echo "15--10" >> /home/rezmo/opendaylight/Inputs.txt
echo "15--14" >> /home/rezmo/opendaylight/Inputs.txt

#./run_scenarios.sh Medium_topo Normal

echo "Algorithm: FT" > /home/rezmo/opendaylight/Inputs.txt
echo "Interval: 20000" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.1*10.0.0.9" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.2*10.0.0.10" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.3*10.0.0.11" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.4*10.0.0.12" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.5*10.0.0.13" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.6*10.0.0.14" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.7*10.0.0.15" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.8*10.0.0.16" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.8*10.0.0.17" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.4*10.0.0.18" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 6,5" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 6,9" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 13,6" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 13,12" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 10,8" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 10,9" >> /home/rezmo/opendaylight/Inputs.txt

#./run_scenarios.sh Medium_topo Fault_Tolerance

echo "Algorithm: DP" > /home/rezmo/opendaylight/Inputs.txt
echo "Interval: 20000" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.1*10.0.0.9" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.2*10.0.0.10" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.3*10.0.0.11" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.4*10.0.0.12" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.5*10.0.0.13" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.6*10.0.0.14" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.7*10.0.0.15" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.8*10.0.0.16" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.8*10.0.0.17" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.4*10.0.0.18" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 6,5" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 6,9" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 13,6" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 13,12" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 10,8" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 10,9" >> /home/rezmo/opendaylight/Inputs.txt

./run_scenarios.sh Medium_topo DP

echo "Algorithm: Normal" > /home/rezmo/opendaylight/Inputs.txt
echo "Interval: 20000" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.1*10.0.0.25" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.2*10.0.0.26" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.3*10.0.0.27" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.4*10.0.0.28" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.5*10.0.0.25" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.6*10.0.0.26" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.7*10.0.0.17" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.8*10.0.0.18" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.9*10.0.0.19" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.10*10.0.0.20" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.11*10.0.0.21" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.12*10.0.0.22" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.13*10.0.0.23" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.14*10.0.0.24" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.15*10.0.0.17" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.16*10.0.0.18" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 8,2" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 8,7" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 18,3" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 18,4" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 14,15" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 14,16" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 17,13" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 17,16" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 20,24" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 20,25" >> /home/rezmo/opendaylight/Inputs.txt
echo "1--2" >> /home/rezmo/opendaylight/Inputs.txt
echo "1--6" >> /home/rezmo/opendaylight/Inputs.txt
echo "1--3" >> /home/rezmo/opendaylight/Inputs.txt
echo "4--3" >> /home/rezmo/opendaylight/Inputs.txt
echo "4--5" >> /home/rezmo/opendaylight/Inputs.txt
echo "4--6" >> /home/rezmo/opendaylight/Inputs.txt
echo "4--9" >> /home/rezmo/opendaylight/Inputs.txt
echo "4--10" >> /home/rezmo/opendaylight/Inputs.txt
echo "9--8" >> /home/rezmo/opendaylight/Inputs.txt
echo "9--10" >> /home/rezmo/opendaylight/Inputs.txt
echo "9--13" >> /home/rezmo/opendaylight/Inputs.txt
echo "19--18" >> /home/rezmo/opendaylight/Inputs.txt
echo "19--20" >> /home/rezmo/opendaylight/Inputs.txt
echo "19--26" >> /home/rezmo/opendaylight/Inputs.txt
echo "28--25" >> /home/rezmo/opendaylight/Inputs.txt
echo "28--27" >> /home/rezmo/opendaylight/Inputs.txt
echo "28--29" >> /home/rezmo/opendaylight/Inputs.txt
#./run_scenarios.sh Large_topo Normal


echo "Algorithm: FT" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.1*10.0.0.25" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.2*10.0.0.26" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.3*10.0.0.27" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.4*10.0.0.28" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.5*10.0.0.25" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.6*10.0.0.26" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.7*10.0.0.17" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.8*10.0.0.18" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.9*10.0.0.19" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.10*10.0.0.20" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.11*10.0.0.21" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.12*10.0.0.22" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.13*10.0.0.23" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.14*10.0.0.24" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.15*10.0.0.17" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.16*10.0.0.18" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 8,2" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 8,7" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 18,3" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 18,4" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 14,15" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 14,16" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 17,13" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 17,16" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 20,24" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 20,25" >> /home/rezmo/opendaylight/Inputs.txt
echo "1--2" >> /home/rezmo/opendaylight/Inputs.txt
echo "1--6" >> /home/rezmo/opendaylight/Inputs.txt
echo "1--3" >> /home/rezmo/opendaylight/Inputs.txt
echo "4--3" >> /home/rezmo/opendaylight/Inputs.txt
echo "4--5" >> /home/rezmo/opendaylight/Inputs.txt
echo "4--6" >> /home/rezmo/opendaylight/Inputs.txt
echo "4--9" >> /home/rezmo/opendaylight/Inputs.txt
echo "4--10" >> /home/rezmo/opendaylight/Inputs.txt
echo "9--8" >> /home/rezmo/opendaylight/Inputs.txt
echo "9--10" >> /home/rezmo/opendaylight/Inputs.txt
echo "9--13" >> /home/rezmo/opendaylight/Inputs.txt
echo "19--18" >> /home/rezmo/opendaylight/Inputs.txt
echo "19--20" >> /home/rezmo/opendaylight/Inputs.txt
echo "19--26" >> /home/rezmo/opendaylight/Inputs.txt
echo "28--25" >> /home/rezmo/opendaylight/Inputs.txt
echo "28--27" >> /home/rezmo/opendaylight/Inputs.txt
echo "28--29" >> /home/rezmo/opendaylight/Inputs.txt

#./run_scenarios.sh Large_topo Fault_Tolerance


echo "Algorithm: DP" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.1*10.0.0.25" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.2*10.0.0.26" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.3*10.0.0.27" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.4*10.0.0.28" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.5*10.0.0.25" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.6*10.0.0.26" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.7*10.0.0.17" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.8*10.0.0.18" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.9*10.0.0.19" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.10*10.0.0.20" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.11*10.0.0.21" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.12*10.0.0.22" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.13*10.0.0.23" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.14*10.0.0.24" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.15*10.0.0.17" >> /home/rezmo/opendaylight/Inputs.txt
echo "Pair: 10.0.0.16*10.0.0.18" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 8,2" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 8,7" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 18,3" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 18,4" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 14,15" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 14,16" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 17,13" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 17,16" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 20,24" >> /home/rezmo/opendaylight/Inputs.txt
echo "Shared: 20,25" >> /home/rezmo/opendaylight/Inputs.txt
echo "1--2" >> /home/rezmo/opendaylight/Inputs.txt
echo "1--6" >> /home/rezmo/opendaylight/Inputs.txt
echo "1--3" >> /home/rezmo/opendaylight/Inputs.txt
echo "4--3" >> /home/rezmo/opendaylight/Inputs.txt
echo "4--5" >> /home/rezmo/opendaylight/Inputs.txt
echo "4--6" >> /home/rezmo/opendaylight/Inputs.txt
echo "4--9" >> /home/rezmo/opendaylight/Inputs.txt
echo "4--10" >> /home/rezmo/opendaylight/Inputs.txt
echo "9--8" >> /home/rezmo/opendaylight/Inputs.txt
echo "9--10" >> /home/rezmo/opendaylight/Inputs.txt
echo "9--13" >> /home/rezmo/opendaylight/Inputs.txt
echo "19--18" >> /home/rezmo/opendaylight/Inputs.txt
echo "19--20" >> /home/rezmo/opendaylight/Inputs.txt
echo "19--26" >> /home/rezmo/opendaylight/Inputs.txt
echo "28--25" >> /home/rezmo/opendaylight/Inputs.txt
echo "28--27" >> /home/rezmo/opendaylight/Inputs.txt
echo "28--29" >> /home/rezmo/opendaylight/Inputs.txt

./run_scenarios.sh Large_topo DP







